-- dofile(LUA_REQUIRE or getenv"LUA_REQUIRE" or "")
-- require=require or dofile

if require then return end
rawdofile = rawdofile or dofile

local Public, Private = {},{}
Require = Public

Private.default_path = {n=3; "", "/usr/local/share/dlua4.0/", "/usr/share/dlua4.0/"}

if getenv("HOME") then
  tinsert(Private.default_path, getenv("HOME").."/share/dlua4.0/")
end

function Private.init_path()
  if DLUA_PATH or getenv("DLUA_PATH") then
    local l_path = {n=0}
    local s = DLUA_PATH or getenv("DLUA_PATH")
    gsub(s, "([^;]+)", function (seg) tinsert(%l_path, seg) end)
    %Public.path = l_path
  else
    %Public.path = %Private.default_path
  end
end

Private.init_path()

Private.loaded = {}

function Private.dofile_on_path(package, path)
  for i = 1,getn(path) do
    local prefix = path[i]
    local file = prefix..package
    local r = rawdofile(file)
    if r then return r end
  end
  return nil
end

function Public.require(package)
  if %Private.loaded[package] then return end
  if %Private.dofile_on_path(package, %Public.path) then
    %Private.loaded[package]=1
  else
    error("required package not found: "..package)
  end
end

function Public.dofile(file)
  local r = rawdofile(file)
  if r then return r end
  return %Private.dofile_on_path(file, %Public.path)
end

require = Public.require

-- Delete this if all the modules you care about use require.
-- dofile = Public.dofile
