if RequireSO then return end

local Public, Private = {},{}
RequireSO = Public

-- Note that we do NOT search the current directlry by default.

Private.default_path = {n=2; "/usr/local/lib/dlua4.0/", "/usr/lib/dlua4.0/"}

if getenv("HOME") then
  tinsert(Private.default_path, getenv("HOME").."/lib/dlua4.0/")
end

function Private.init_path()
  if DLUA_SO_PATH or getenv("DLUA_SO_PATH") then
    local l_path = {n=0}
    local s = DLUA_SO_PATH or getenv("DLUA_SO_PATH")
    gsub(s, "([^;]+)", function (seg) tinsert(%l_path, seg) end)
    %Public.path = l_path
  else
    %Public.path = %Private.default_path
  end
end

Private.init_path()

Private.loaded = {}

function Private.loadlib2_on_path(package, path, cfunction)
  for i = 1,getn(path) do
    local prefix = path[i]
    local file = prefix..package
    local r = loadlib2(file, cfunction)
    if r then return r end
  end
  return nil
end

function Public.require(package, cfunction)
  if %Private.loaded[package] then return end
  if %Private.loadlib2_on_path(package, %Public.path, cfunction) then
    %Private.loaded[package]=1
  else
    error("required shared object not found: "..package)
  end
end

-- function Public.dofile(file)
--  local r = rawdofile(file)
--  if r then return r end
--  return %Private.dofile_on_path(file, %Public.path)
-- end
